	.file "..\src\dct4x4.c";
//  Compilation time: Wed Jul 20 18:43:56 2016
//  Compiler options: -c -file-attr ProjectName=myOptimizationExample -proc ADSP-BF707 -flags-compiler --no_wrap_diagnostics -si-revision any -g -save-temps -path-output .\src -DCORE0 -D_DEBUG -IC:\Projects\myOptimizationExample\system -structs-do-not-overlap -no-const-strings -no-multiline -warn-protos -double-size-32 -decls-strong -cplbs -gnu-style-dependencies -MD -Mo src\dct4x4.d -o src\dct4x4.doj
//  Compiler version: 8.6.0.0 (BUILD-B-REL-CCES2_2-20160219_1817)
//  Architecture: ADSP-BF707
//  Silicon revision: any
//  Anomalies summary:
//   Never on: w_05000046
//   Disabled: w_05000048, w_05000074_16000015, w_05000103, w_05000104, w_05000120, w_05000122, w_05000127, w_05000157, w_05000310_16000013, w_05000198, w_05000202, w_05000209, w_05000227, w_05000244, w_05000245_16000014, w_05000246, w_05000248, w_05000262, w_05000264, w_05000283, w_F3_F_021, w_F3_F_008_F3_F_013, w_05000312, w_05000371, w_05000428, w_05000426_16000012, w_05000443_16000010, w_05000412, w_05000010, w_05000477_16000009, w_05000506_16000043
//   Enabled: w_19000010, w_19000019

.MESSAGE/SUPPRESS 5500;
.MESSAGE/SUPPRESS 5508;


	.section/DOUBLE32 program;

.epctext:

	.align 2;
_C_ITransform4x4:
.LN_C_ITransform4x4:
//-------------------------------------------------------------------
//  Procedure statistics:
//  Frame size            = 60 
//  Scratch registers used: {R0-R3,P0-P2,ASTAT0-ASTAT1,CC}
//  Call preserved registers used: {R4-R7,FP,SP,RETS}
//-------------------------------------------------------------------
// line "..\src\dct4x4.c":3
	LINK 36;
	[--SP] = (R7:4);
	[FP + 8] = R0;
.LN0:
// line 8
	[FP + -36] = R0;
.LN1:
// line 9
	R1 = 0;
	[FP + 16] = R1;

.P33L1:
//-------------------------------------------------------------------
//   Loop at "..\src\dct4x4.c" line 9 col 2
//-------------------------------------------------------------------
//   This loop executes 1 iteration of the original loop in an estimated 79 
//   cycles (includes 20 stalls).
//-------------------------------------------------------------------
//   This loop's resource usage is:
//     16-bit Instruction  used  59 out of  158 ( 37.3%)
//     32-bit Instruction  used  28 out of   79 ( 35.4%)
//     Group 1             used  45 out of  158 ( 28.5%)
//     Store               used  14 out of   79 ( 17.7%)
//-------------------------------------------------------------------
	// -- 4 stalls --
.LN2:
	R0 = [FP + 16];
	CC = R0 <= 3;
	if !CC jump .P33L3 ;

.LN3:
// line 11
	P0 = [FP + -36];
	// -- 3 stalls --
	R0 = W[P0] (X);
	[FP + -32] = R0;
	P1 = P0;
.LN4:
// line 12
	P0 += 2;
	R5 = W[P0] (X);
	[FP + -28] = R5;
	P0 = P1;
.LN5:
// line 13
	P1 += 4;
	R2 = W[P1] (X);
	[FP + -24] = R2;
	P1 = P0;
.LN6:
// line 14
	P0 += 6;
	R6 = W[P0] (X);
	[FP + -20] = R6;
.LN7:
// line 15
	R3 = R0 + R2 (NS);
	R7 = 13;
	// -- stall --
	R3 = R3 * R7 (IS, NS);
	[FP + -16] = R3;
.LN8:
// line 16
	R0 = R0 - R2 (NS);
	// -- stall --
	R0 = R0 * R7 (IS, NS);
	[FP + -12] = R0;
.LN9:
// line 17
	R4 = 7;
	// -- stall --
	R0 = R5 * R4 (IS, NS);
	R7 = 17;
	// -- stall --
	R2 = R6 * R7 (IS, NS);
	R0 = R0 - R2 (NS);
	[FP + -8] = R0;
.LN10:
// line 18
	R0 = R5 * R7 (IS, NS);
	R2 = R6 * R4 (IS, NS);
	R0 = R0 + R2 (NS);
	[FP + -4] = R0;
.LN11:
// line 19
	R0 = R3 + R0 (NS);
	W[P1] = R0.L;
.LN12:
// line 20
	R0 = [FP + -16];
	R2 = [FP + -4];
	R0 = R0 - R2 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 6] = R0;
.LN13:
// line 21
	R0 = [FP + -12];
	R2 = [FP + -8];
	R0 = R0 + R2 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 2] = R0;
.LN14:
// line 22
	R0 = [FP + -12];
	R2 = [FP + -8];
	R0 = R0 - R2 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 4] = R0;
.LN15:
// line 23
	R0 = [FP + -36];
	R0 += 8;
	[FP + -36] = R0;
.LN16:
// line 9
	R0 = [FP + 16];
	R0 += 1;
	[FP + 16] = R0;
	jump.s .P33L1;
//-------------------------------------------------------------------
//   End Loop L1
//-------------------------------------------------------------------

.P33L3:
//-------------------------------------------------------------------
//   Part of top level (no loop)
//-------------------------------------------------------------------
.LN17:
// line 26
	R0 = [FP + 8];
	[FP + -36] = R0;
.LN18:
// line 27
	[FP + 12] = R1;

.P33L4:
//-------------------------------------------------------------------
//   Loop at "..\src\dct4x4.c" line 27 col 2
//-------------------------------------------------------------------
//   This loop executes 1 iteration of the original loop in an estimated 79 
//   cycles (includes 20 stalls).
//-------------------------------------------------------------------
//   This loop's resource usage is:
//     16-bit Instruction  used  59 out of  158 ( 37.3%)
//     32-bit Instruction  used  28 out of   79 ( 35.4%)
//     Group 1             used  45 out of  158 ( 28.5%)
//     Store               used  10 out of   79 ( 12.7%)
//-------------------------------------------------------------------
	// -- 4 stalls --
.LN19:
	R0 = [FP + 12];
	CC = R0 <= 3;
	if !CC jump .P33L6 ;

.LN20:
// line 29
	P0 = [FP + -36];
	// -- 3 stalls --
	R0 = W[P0] (X);
	P1 = P0;
	P0 += 16;
	R1 = W[P0] (X);
	R0 = R0 + R1 (NS);
	R1 = 13;
	// -- stall --
	R3 = R0 * R1 (IS, NS);
	[FP + -16] = R3;
.LN21:
// line 30
	R0 = W[P1] (X);
	R2 = W[P0] (X);
	R0 = R0 - R2 (NS);
	// -- stall --
	R0 = R0 * R1 (IS, NS);
	[FP + -12] = R0;
	P0 = P1;
.LN22:
// line 31
	P1 += 8;
	R0 = W[P1] (X);
	R7 = 7;
	// -- stall --
	R0 = R0 * R7 (IS, NS);
	P2 = P0;
	P0 += 24;
	R1 = W[P0] (X);
	R2 = 17;
	// -- stall --
	R1 = R1 * R2 (IS, NS);
	R0 = R0 - R1 (NS);
	[FP + -8] = R0;
.LN23:
// line 32
	R0 = W[P1] (X);
	R0 = R0 * R2 (IS, NS);
	R1 = W[P0] (X);
	R1 = R1 * R7 (IS, NS);
	R0 = R0 + R1 (NS);
	[FP + -4] = R0;
.LN24:
// line 33
	R0 = R3 + R0 (NS);
	W[P2] = R0.L;
.LN25:
// line 34
	R0 = [FP + -16];
	R1 = [FP + -4];
	R0 = R0 - R1 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 24] = R0;
.LN26:
// line 35
	R0 = [FP + -12];
	R1 = [FP + -8];
	R0 = R0 + R1 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 8] = R0;
.LN27:
// line 36
	R0 = [FP + -12];
	R1 = [FP + -8];
	R0 = R0 - R1 (NS);
	P1 = [FP + -36];
	// -- 3 stalls --
	W[P1 + 16] = R0;
.LN28:
// line 37
	R0 = [FP + -36];
	R0 += 2;
	[FP + -36] = R0;
.LN29:
// line 27
	R0 = [FP + 12];
	R0 += 1;
	[FP + 12] = R0;
	jump.s .P33L4;
//-------------------------------------------------------------------
//   End Loop L4
//-------------------------------------------------------------------

.P33L6:
//-------------------------------------------------------------------
//   Part of top level (no loop)
//-------------------------------------------------------------------
.LN30:
// line 39
	(R7:4) = [SP++];
	UNLINK;
	RTS;
.LN._C_ITransform4x4.end:
._C_ITransform4x4.end:
	.global _C_ITransform4x4;
	.type _C_ITransform4x4,STT_FUNC;

	.file_attr ProjectName="myOptimizationExample";
	.file_attr FuncName="_C_ITransform4x4";
	.file_attr Content="Code";
.epctext.end:

	.section .debug_abbrev;

	.align 1;
	.type .epcabbrev,STT_OBJECT;
.epcabbrev:
	.byte =
		0x01,0x11,0x01,0x03,0x08,0x13,0x0B,0x10,0x06,0x43,0x06,0x1B,
		0x08,0x25,0x08,0x42,0x0B,0x00,0x00,0x02,0x24,0x00,0x03,0x08,
		0x3E,0x0B,0x0B,0x0F,0x00,0x00,0x03,0x24,0x00,0x03,0x08,0x3E,
		0x0B,0x5F,0x0F,0x5B,0x0F,0x0B,0x0F,0x00,0x00,0x04,0x2E,0x01,
		0x01,0x13,0x03,0x08,0x32,0x0B,0x11,0x01,0x12,0x01,0x27,0x0C,
		0x3F,0x0C,0x20,0x0B,0x00,0x00,0x05,0x05,0x00,0x03,0x08,0x49,
		0x13,0x02,0x09,0x34,0x0C,0x00,0x00,0x06,0x0B,0x01,0x01,0x13,
		0x11,0x01,0x12,0x01,0x00,0x00,0x07,0x34,0x00,0x03,0x08,0x32,
		0x0B,0x49,0x13,0x02,0x09,0x2C,0x06,0x3F,0x0C,0x00,0x00,0x08,
		0x0F,0x00,0x33,0x0F,0x49,0x13,0x00,0x00,0x00;
.epcabbrev.end:

	.section .debug_info;

	.align 1;
	.type .epcdebug,STT_OBJECT;
.epcdebug:
	.byte =
		0xB6,0x04,0x00,0x00,0x02,0x00;
	.byte4 = .epcabbrev;
	.byte =
		0x04,0x01,0x2E,0x2E,0x5C,0x73,0x72,0x63,0x5C,0x64,0x63,0x74,
		0x34,0x78,0x34,0x2E,0x63,0x00,0x0C;
	.byte4 = .epcline;
	.inc/binary ".\src\dct4x4.sbn", 0, 912;
	.byte4 = .LN_C_ITransform4x4;
	.byte4 = .LN._C_ITransform4x4.end;
	.byte =
		0x01,0x01,0x00,0x05,0x69,0x6E,0x00,0xB3,0x04,0x00,0x00,0x02,
		0x7F,0x08,0x00,0x06,0x00,0x00,0x00,0x00;
	.byte4 = .LN0;
	.byte4 = .LN._C_ITransform4x4.end;
	.inc/binary ".\src\dct4x4.sbn", 912, 159;
	.byte4 = .LN_C_ITransform4x4;
	.byte4 = .LN._C_ITransform4x4.end;
	.byte =
		0x07,0x69,0x00,0x01,0xC9,0x01,0x00,0x00,0x02,0x7F,0x10,0x00,
		0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00;
	.byte4 = .LN_C_ITransform4x4;
	.byte4 = .LN._C_ITransform4x4.end;
	.byte =
		0x07,0x69,0x00,0x01,0xC9,0x01,0x00,0x00,0x02,0x7F,0x0C,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x9E,0x01,0x00,
		0x00,0x08,0x00,0xC9,0x01,0x00,0x00,0x00;
.epcdebug.end:

	.section .debug_line;

	.align 1;
	.type .epcline,STT_OBJECT;
.epcline:
	.inc/binary ".\src\dct4x4.sbn", 1071, 169;
	.byte4 = .LN_C_ITransform4x4;
	.byte =
		0x04,0x01,0x05,0x01,0x0B,0x00,0x05,0x02;
	.byte4 = .LN0;
	.byte =
		0x05,0x02,0x0E,0x00,0x05,0x02;
	.byte4 = .LN1;
	.byte =
		0x05,0x0D,0x0A,0x00,0x05,0x02;
	.byte4 = .LN2;
	.byte =
		0x05,0x02,0x01,0x00,0x05,0x02;
	.byte4 = .LN3;
	.byte =
		0x05,0x03,0x0B,0x00,0x05,0x02;
	.byte4 = .LN4;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN5;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN6;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN7;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN8;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN9;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN10;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN11;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN12;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN13;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN14;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN15;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN16;
	.byte =
		0x05,0x1A,0x03,0x72,0x01,0x00,0x05,0x02;
	.byte4 = .LN17;
	.byte =
		0x05,0x02,0x1A,0x00,0x05,0x02;
	.byte4 = .LN18;
	.byte =
		0x05,0x0D,0x0A,0x00,0x05,0x02;
	.byte4 = .LN19;
	.byte =
		0x05,0x02,0x01,0x00,0x05,0x02;
	.byte4 = .LN20;
	.byte =
		0x05,0x03,0x0B,0x00,0x05,0x02;
	.byte4 = .LN21;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN22;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN23;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN24;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN25;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN26;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN27;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN28;
	.byte =
		0x0A,0x00,0x05,0x02;
	.byte4 = .LN29;
	.byte =
		0x05,0x1A,0x03,0x76,0x01,0x00,0x05,0x02;
	.byte4 = .LN30;
	.byte =
		0x05,0x01,0x15,0x00,0x05,0x02;
	.byte4 = .LN._C_ITransform4x4.end;
	.byte =
		0x00,0x01,0x01;
.epcline.end:

	.section .debug_pubnames;

	.align 1;
.epcpubnames:
	.type .epcpubnames,STT_OBJECT;
	.byte =
		0x22,0x00,0x00,0x00,0x02,0x00;
	.byte4 = .epcdebug;
	.byte =
		0xBA,0x04,0x00,0x00,0x9B,0x03,0x00,0x00,0x43,0x5F,0x49,0x54,
		0x72,0x61,0x6E,0x73,0x66,0x6F,0x72,0x6D,0x34,0x78,0x34,0x00,
		0x00,0x00,0x00,0x00;
.epcpubnames.end:

	.section .debug_aranges;

	.align 1;
.epcaranges:
	.type .epcaranges,STT_OBJECT;
	.byte =
		0x1C,0x00,0x00,0x00,0x02,0x00;
	.byte4 = .epcdebug;
	.byte =
		0x04,0x00,0x00,0x00,0x00,0x00;
	.byte4 = .LN_C_ITransform4x4;
	.byte4 = .LN._C_ITransform4x4.end-.LN_C_ITransform4x4;
	.byte =
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;
.epcaranges.end:
